diff --git a/pithos-macos/PithosBrowserController.m b/pithos-macos/PithosBrowserController.m
index b976f87..0bcb45e 100644
--- a/pithos-macos/PithosBrowserController.m
+++ b/pithos-macos/PithosBrowserController.m
@@ -1426,12 +1751,15 @@ forDraggedRowsWithIndexes:(NSIndexSet *)rowIndexes inColumn:(NSInteger)column {
 
 - (void)uploadObjectUsingHashMapFinished:(ASIPithosObjectRequest *)objectRequest {
     NSAutoreleasePool *pool = [[NSAutoreleasePool alloc] init];
+    NSOperation *operation = [objectRequest.userInfo objectForKey:@"operation"];
     NSLog(@"Upload using hashmap finished: %@", objectRequest.url);
     NSString *fileName = [objectRequest.userInfo objectForKey:@"fileName"];
     PithosActivity *activity = [objectRequest.userInfo objectForKey:@"activity"];
     NSUInteger totalBytes = activity.totalBytes;
     NSUInteger currentBytes = activity.currentBytes;
-    if (objectRequest.responseStatusCode == 201) {
+    if (operation.isCancelled) {
+        [self requestFailed:objectRequest];
+    } else if (objectRequest.responseStatusCode == 201) {
         NSLog(@"Object created: %@", objectRequest.url);
         dispatch_async(dispatch_get_main_queue(), ^{
             [activityFacility endActivity:activity 
@@ -1510,11 +1838,14 @@ forDraggedRowsWithIndexes:(NSIndexSet *)rowIndexes inColumn:(NSInteger)column {
 
 - (void)uploadMissingBlockFinished:(ASIPithosContainerRequest *)containerRequest {
     NSAutoreleasePool *pool = [[NSAutoreleasePool alloc] init];
+    NSOperation *operation = [containerRequest.userInfo objectForKey:@"operation"];
     NSLog(@"Upload of missing block finished: %@", containerRequest.url);
     NSUInteger blockSize = [[containerRequest.userInfo objectForKey:@"blockSize"] unsignedIntegerValue];
     NSString *fileName = [containerRequest.userInfo objectForKey:@"fileName"];
     PithosActivity *activity = [containerRequest.userInfo objectForKey:@"activity"];
-    if (containerRequest.responseStatusCode == 202) {
+    if (operation.isCancelled) {
+        [self requestFailed:containerRequest];
+    } else if (containerRequest.responseStatusCode == 202) {
         NSIndexSet *missingBlocks = [containerRequest.userInfo objectForKey:@"missingBlocks"];
         NSUInteger missingBlockIndex = [[containerRequest.userInfo objectForKey:@"missingBlockIndex"] unsignedIntegerValue];
         missingBlockIndex = [missingBlocks indexGreaterThanIndex:missingBlockIndex];
@@ -1569,8 +1900,11 @@ forDraggedRowsWithIndexes:(NSIndexSet *)rowIndexes inColumn:(NSInteger)column {
 
 - (void)moveFinished:(ASIPithosObjectRequest *)objectRequest {
     NSAutoreleasePool *pool = [[NSAutoreleasePool alloc] init];
+    NSOperation *operation = [objectRequest.userInfo objectForKey:@"operation"];
     NSLog(@"Move object finished: %@", objectRequest.url);
-    if (objectRequest.responseStatusCode == 201) {
+    if (operation.isCancelled) {
+        [self requestFailed:objectRequest];
+    } else if (objectRequest.responseStatusCode == 201) {
         dispatch_async(dispatch_get_main_queue(), ^{
             [activityFacility endActivity:[objectRequest.userInfo objectForKey:@"activity"] 
                               withMessage:[objectRequest.userInfo objectForKey:@"finishedActivityMessage"]];
@@ -1594,8 +1928,11 @@ forDraggedRowsWithIndexes:(NSIndexSet *)rowIndexes inColumn:(NSInteger)column {
 
 - (void)copyFinished:(ASIPithosObjectRequest *)objectRequest {
     NSAutoreleasePool *pool = [[NSAutoreleasePool alloc] init];
+    NSOperation *operation = [objectRequest.userInfo objectForKey:@"operation"];
     NSLog(@"Copy object finished: %@", objectRequest.url);
-    if (objectRequest.responseStatusCode == 201) {
+    if (operation.isCancelled) {
+        [self requestFailed:objectRequest];
+    } else if (objectRequest.responseStatusCode == 201) {
         dispatch_async(dispatch_get_main_queue(), ^{
             [activityFacility endActivity:[objectRequest.userInfo objectForKey:@"activity"] 
                               withMessage:[objectRequest.userInfo objectForKey:@"finishedActivityMessage"]];
@@ -1619,8 +1956,11 @@ forDraggedRowsWithIndexes:(NSIndexSet *)rowIndexes inColumn:(NSInteger)column {
 
 - (void)deleteObjectFinished:(ASIPithosObjectRequest *)objectRequest {
     NSAutoreleasePool *pool = [[NSAutoreleasePool alloc] init];
+    NSOperation *operation = [objectRequest.userInfo objectForKey:@"operation"];
     NSLog(@"Delete object finished: %@", objectRequest.url);
-    if (objectRequest.responseStatusCode == 204) {
+    if (operation.isCancelled) {
+        [self requestFailed:objectRequest];
+    } else if (objectRequest.responseStatusCode == 204) {
         dispatch_async(dispatch_get_main_queue(), ^{
             [activityFacility endActivity:[objectRequest.userInfo objectForKey:@"activity"] 
                               withMessage:[objectRequest.userInfo objectForKey:@"finishedActivityMessage"]];
@@ -1945,12 +2285,21 @@ forDraggedRowsWithIndexes:(NSIndexSet *)rowIndexes inColumn:(NSInteger)column {
 - (void)menuNewFolder:(NSMenuItem *)sender {
     PithosNode *node = (PithosNode *)[sender representedObject];
     if ([node class] == [PithosContainerNode class]) {
-        dispatch_async(dispatch_get_global_queue(DISPATCH_QUEUE_PRIORITY_DEFAULT, 0), ^{
+        // Operation: Create (upload) a new root application/directory object
+        __block NSOperation *operation = [NSBlockOperation blockOperationWithBlock:^{
             NSAutoreleasePool *pool = [[NSAutoreleasePool alloc] init];
+            if (operation.isCancelled) {
+                [pool drain];
+                return;
+            }
             NSString *safeObjectName = [PithosUtilities safeSubdirNameForPithos:pithos 
                                                                   containerName:node.pithosContainer.name 
                                                                      subdirName:@"untitled folder"];
             NSString *fileName = [safeObjectName lastPathComponent];
+            if (operation.isCancelled) {
+                [pool drain];
+                return;
+            }
             ASIPithosObjectRequest *objectRequest = [ASIPithosObjectRequest writeObjectDataRequestWithPithos:pithos 
                                                                                                containerName:node.pithosContainer.name 
                                                                                                   objectName:safeObjectName 
@@ -1982,19 +2331,29 @@ forDraggedRowsWithIndexes:(NSIndexSet *)rowIndexes inColumn:(NSInteger)column {
                                       NSStringFromSelector(@selector(uploadDirectoryObjectFinished:)), @"didFinishSelector", 
                                       NSStringFromSelector(@selector(requestFailed:)), @"didFailSelector", 
                                       uploadNetworkQueue, @"networkQueue", 
-                                      @"uploadQueue", @"queueType", 
+                                      @"upload", @"operationType", 
                                       nil];
             [uploadNetworkQueue addOperation:[PithosUtilities prepareRequest:objectRequest priority:NSOperationQueuePriorityHigh]];
             [pool drain];
-        });
+        }];
+        [uploadQueue addOperation:operation];
     } else if (([node class] == [PithosSubdirNode class]) && 
                (node.pithosObject.subdir || ![node.pithosObject.name hasSuffix:@"/"])) {
-        dispatch_async(dispatch_get_global_queue(DISPATCH_QUEUE_PRIORITY_DEFAULT, 0), ^{
+        // Operation: Create (upload) a new aplication/directory object
+        __block NSOperation *operation = [NSBlockOperation blockOperationWithBlock:^{
             NSAutoreleasePool *pool = [[NSAutoreleasePool alloc] init];
+            if (operation.isCancelled) {
+                [pool drain];
+                return;
+            }
             NSString *safeObjectName = [PithosUtilities safeSubdirNameForPithos:pithos 
                                                                   containerName:node.pithosContainer.name 
                                                                      subdirName:[node.pithosObject.name stringByAppendingPathComponent:@"untitled folder"]];
             NSString *fileName = [safeObjectName lastPathComponent];
+            if (operation.isCancelled) {
+                [pool drain];
+                return;
+            }
             ASIPithosObjectRequest *objectRequest = [ASIPithosObjectRequest writeObjectDataRequestWithPithos:pithos 
                                                                                                containerName:node.pithosContainer.name 
                                                                                                   objectName:safeObjectName 
@@ -2026,11 +2385,12 @@ forDraggedRowsWithIndexes:(NSIndexSet *)rowIndexes inColumn:(NSInteger)column {
                                       NSStringFromSelector(@selector(uploadDirectoryObjectFinished:)), @"didFinishSelector", 
                                       NSStringFromSelector(@selector(requestFailed:)), @"didFailSelector", 
                                       uploadNetworkQueue, @"networkQueue", 
-                                      @"uploadQueue", @"queueType", 
+                                      @"upload", @"operationType", 
                                       nil];
             [uploadNetworkQueue addOperation:[PithosUtilities prepareRequest:objectRequest priority:NSOperationQueuePriorityHigh]];
             [pool drain];
-        });
+        }];
+        [uploadQueue addOperation:operation];
     }
 }
 
@@ -2044,14 +2404,23 @@ forDraggedRowsWithIndexes:(NSIndexSet *)rowIndexes inColumn:(NSInteger)column {
     for (PithosNode *node in ((NSArray *)[sender representedObject])) {
         if (([node class] == [PithosObjectNode class]) || 
             (([node class] == [PithosSubdirNode class]) && !node.pithosObject.subdir && [node.pithosObject.name hasSuffix:@"/"])) {
-            dispatch_async(dispatch_get_global_queue(DISPATCH_QUEUE_PRIORITY_DEFAULT, 0), ^{
+            // Operation: Delete an object or subdir/ node
+            __block NSOperation *operation = [NSBlockOperation blockOperationWithBlock:^{
                 NSAutoreleasePool *pool = [[NSAutoreleasePool alloc] init];
+                if (operation.isCancelled) {
+                    [pool drain];
+                    return;
+                }
                 NSString *fileName = [node.pithosObject.name lastPathComponent];
                 if ([node.pithosObject.name hasSuffix:@"/"])
                     fileName = [fileName stringByAppendingString:@"/"];
                 ASIPithosObjectRequest *objectRequest = [ASIPithosObjectRequest deleteObjectRequestWithPithos:pithos 
                                                                                                 containerName:node.pithosContainer.name 
                                                                                                    objectName:node.pithosObject.name];
+                if (operation.isCancelled) {
+                    [pool drain];
+                    return;
+                }
                 objectRequest.delegate = self;
                 objectRequest.didFinishSelector = @selector(performRequestFinishedDelegateInBackground:);
                 objectRequest.didFailSelector = @selector(performRequestFailedDelegateInBackground:);
@@ -2070,19 +2439,31 @@ forDraggedRowsWithIndexes:(NSIndexSet *)rowIndexes inColumn:(NSInteger)column {
                                           NSStringFromSelector(@selector(deleteObjectFinished:)), @"didFinishSelector", 
                                           NSStringFromSelector(@selector(requestFailed:)), @"didFailSelector", 
                                           deleteNetworkQueue, @"networkQueue", 
-                                          @"deleteQueue", @"queueType", 
+                                          @"delete", @"operationType", 
                                           nil];
                 [deleteNetworkQueue addOperation:[PithosUtilities prepareRequest:objectRequest priority:NSOperationQueuePriorityHigh]];
                 [pool drain];
-            });
+            }];
+            [deleteQueue addOperation:operation];
         } else if ([node class] == [PithosSubdirNode class]) {
-            dispatch_async(dispatch_get_global_queue(DISPATCH_QUEUE_PRIORITY_DEFAULT, 0), ^{
+            // Operation: Delete a subdir node and its descendants
+            // The resulting ASIPithosObjectRequests are chained through dependencies
+            __block NSOperation *operation = [NSBlockOperation blockOperationWithBlock:^{
                 NSAutoreleasePool *pool = [[NSAutoreleasePool alloc] init];
+                if (operation.isCancelled) {
+                    [pool drain];
+                    return;
+                }
                 NSArray *objectRequests = [PithosUtilities deleteObjectRequestsForSubdirWithPithos:pithos 
                                                                                      containerName:node.pithosContainer.name 
                                                                                         objectName:node.pithosObject.name];
-                if (objectRequests) {
+                if (!operation.isCancelled && objectRequests) {
+                    ASIPithosObjectRequest *previousObjectRequest = nil;
                     for (ASIPithosObjectRequest *objectRequest in objectRequests) {
+                        if (operation.isCancelled) {
+                            [pool drain];
+                            return;
+                        }
                         objectRequest.delegate = self;
                         objectRequest.didFinishSelector = @selector(performRequestFinishedDelegateInBackground:);
                         objectRequest.didFailSelector = @selector(performRequestFailedDelegateInBackground:);
@@ -2101,13 +2482,17 @@ forDraggedRowsWithIndexes:(NSIndexSet *)rowIndexes inColumn:(NSInteger)column {
                           NSStringFromSelector(@selector(deleteObjectFinished:)), @"didFinishSelector", 
                           NSStringFromSelector(@selector(requestFailed:)), @"didFailSelector", 
                           deleteNetworkQueue, @"networkQueue", 
-                          @"deleteQueue", @"queueType", 
+                          @"delete", @"operationType", 
                           nil]];
+                        if (previousObjectRequest)
+                            [objectRequest addDependency:previousObjectRequest];
+                        previousObjectRequest = objectRequest;
                         [deleteNetworkQueue addOperation:[PithosUtilities prepareRequest:objectRequest priority:NSOperationQueuePriorityHigh]];
                     }
                 }
                 [pool drain];
-            });
+            }];
+            [deleteQueue addOperation:operation];
         }
     }
 }
@@ -2118,19 +2503,24 @@ forDraggedRowsWithIndexes:(NSIndexSet *)rowIndexes inColumn:(NSInteger)column {
             (([node class] == [PithosSubdirNode class]) && 
              !node.pithosObject.subdir &&
              [node.pithosObject.name hasSuffix:@"/"])) {
-            dispatch_async(dispatch_get_global_queue(DISPATCH_QUEUE_PRIORITY_DEFAULT, 0), ^{
+            // Operation: Move to trash an object or subdir/ node
+            __block NSOperation *operation = [NSBlockOperation blockOperationWithBlock:^{
                 NSAutoreleasePool *pool = [[NSAutoreleasePool alloc] init];
+                if (operation.isCancelled) {
+                    [pool drain];
+                    return;
+                }
                 NSString *safeObjectName = [PithosUtilities safeObjectNameForPithos:pithos 
                                                                       containerName:@"trash" 
                                                                          objectName:node.pithosObject.name];
-                if (safeObjectName) {
+                if (!operation.isCancelled && safeObjectName) {
                     ASIPithosObjectRequest *objectRequest = [PithosUtilities moveObjectRequestWithPithos:pithos 
                                                                                            containerName:node.pithosContainer.name 
                                                                                               objectName:node.pithosObject.name 
                                                                                 destinationContainerName:@"trash" 
                                                                                    destinationObjectName:safeObjectName 
                                                                                            checkIfExists:NO];
-                    if (objectRequest) {
+                    if (!operation.isCancelled && objectRequest) {
                         objectRequest.delegate = self;
                         objectRequest.didFinishSelector = @selector(performRequestFinishedDelegateInBackground:);
                         objectRequest.didFailSelector = @selector(performRequestFailedDelegateInBackground:);
@@ -2153,28 +2543,40 @@ forDraggedRowsWithIndexes:(NSIndexSet *)rowIndexes inColumn:(NSInteger)column {
                           NSStringFromSelector(@selector(moveFinished:)), @"didFinishSelector", 
                           NSStringFromSelector(@selector(requestFailed:)), @"didFailSelector", 
                           moveNetworkQueue, @"networkQueue", 
-                          @"moveQueue", @"queueType", 
+                          @"move", @"operationType", 
                           nil]];
                         [moveNetworkQueue addOperation:[PithosUtilities prepareRequest:objectRequest priority:NSOperationQueuePriorityHigh]];
                     }
                 }
                 [pool drain];
-            });
+            }];
+            [moveQueue addOperation:operation];
         } else if ([node class] == [PithosSubdirNode class]) {
-            dispatch_async(dispatch_get_global_queue(DISPATCH_QUEUE_PRIORITY_DEFAULT, 0), ^{
+            // Operation: Move to trash a subdir node and its descendants
+            // The resulting ASIPithosObjectRequests are chained through dependencies
+            __block NSOperation *operation = [NSBlockOperation blockOperationWithBlock:^{
                 NSAutoreleasePool *pool = [[NSAutoreleasePool alloc] init];
+                if (operation.isCancelled) {
+                    [pool drain];
+                    return;
+                }
                 NSString *safeObjectName = [PithosUtilities safeSubdirNameForPithos:pithos 
                                                                       containerName:@"trash" 
                                                                          subdirName:node.pithosObject.name];
-                if (safeObjectName) {
+                if (!operation.isCancelled && safeObjectName) {
                     NSArray *objectRequests = [PithosUtilities moveObjectRequestsForSubdirWithPithos:pithos 
                                                                                        containerName:node.pithosContainer.name 
                                                                                           objectName:node.pithosObject.name 
                                                                             destinationContainerName:@"trash" 
                                                                                destinationObjectName:safeObjectName 
                                                                                        checkIfExists:NO];
-                    if (objectRequests) {
+                    if (!operation.isCancelled && objectRequests) {
+                        ASIPithosObjectRequest *previousObjectRequest = nil;
                         for (ASIPithosObjectRequest *objectRequest in objectRequests) {
+                            if (operation.isCancelled) {
+                                [pool drain];
+                                return;
+                            }
                             objectRequest.delegate = self;
                             objectRequest.didFinishSelector = @selector(performRequestFinishedDelegateInBackground:);
                             objectRequest.didFailSelector = @selector(performRequestFailedDelegateInBackground:);
@@ -2197,14 +2599,18 @@ forDraggedRowsWithIndexes:(NSIndexSet *)rowIndexes inColumn:(NSInteger)column {
                               NSStringFromSelector(@selector(moveFinished:)), @"didFinishSelector", 
                               NSStringFromSelector(@selector(requestFailed:)), @"didFailSelector", 
                               moveNetworkQueue, @"networkQueue", 
-                              @"moveQueue", @"queueType", 
+                              @"move", @"operationType", 
                               nil]];
+                            if (previousObjectRequest)
+                                [objectRequest addDependency:previousObjectRequest];
+                            previousObjectRequest = objectRequest;
                             [moveNetworkQueue addOperation:[PithosUtilities prepareRequest:objectRequest priority:NSOperationQueuePriorityHigh]];
                         }
                     }
                 }
                 [pool drain];
-            });
+            }];
+            [moveQueue addOperation:operation];
         }
     }
 }
diff --git a/pithos-macos/PithosContainerNode.m b/pithos-macos/PithosContainerNode.m
index 0f866b3..1752a0c 100644
--- a/pithos-macos/PithosContainerNode.m
+++ b/pithos-macos/PithosContainerNode.m
@@ -106,6 +106,15 @@ static NSImage *sharedIcon = nil;
 #pragma mark -
 #pragma mark Properties
 
+- (void)setPithos:(ASIPithos *)aPithos {
+    if (aPithos && ![aPithos isEqualTo:pithos]) {
+        [pithos release];
+        pithos = [aPithos retain];
+        [url release];
+        url = nil;
+    }
+}
+
 - (NSString *)url {
     if (url == nil)
         url = [[NSString alloc] initWithFormat:@"%@/%@%@", 
@@ -413,17 +422,39 @@ static NSImage *sharedIcon = nil;
 
 - (void)containerMetadataRequestFailed:(ASIPithosContainerRequest *)request {
     NSAutoreleasePool *pool = [[NSAutoreleasePool alloc] init];
-    if ([request isEqualTo:applyMetadataContainerRequest]) {
-        [PithosUtilities httpRequestErrorAlertWithRequest:applyMetadataContainerRequest];
-        @synchronized(self) {
-            [applyMetadataContainerRequest release];
-            applyMetadataContainerRequest = nil;
+    NSUInteger retries = [[request.userInfo objectForKey:@"retries"] unsignedIntegerValue];
+    if (retries > 0) {
+        ASIPithosContainerRequest *newRequest = (ASIPithosContainerRequest *)[PithosUtilities copyRequest:request];
+        [(NSMutableDictionary *)(newRequest.userInfo)setObject:[NSNumber numberWithUnsignedInteger:(--retries)] forKey:@"retries"];
+        if ([request isEqualTo:applyMetadataContainerRequest]) {
+            @synchronized(self) {
+                [applyMetadataContainerRequest release];
+                applyMetadataContainerRequest = newRequest;
+            }
+        } else if ([request isEqualTo:refreshMetadataContainerRequest]) {
+            @synchronized(self) {
+                [refreshMetadataContainerRequest release];
+                refreshMetadataContainerRequest = newRequest;
+            }
         }
-    } else if ([request isEqualTo:refreshMetadataContainerRequest]) {
-        [PithosUtilities httpRequestErrorAlertWithRequest:refreshMetadataContainerRequest];
-        @synchronized(self) {
-            [refreshMetadataContainerRequest release];
-            refreshMetadataContainerRequest = nil;
+        [[PithosUtilities prepareRequest:newRequest priority:[[newRequest.userInfo objectForKey:@"priority"] integerValue]] startAsynchronous];
+    } else {
+        if ([request isEqualTo:applyMetadataContainerRequest]) {
+            dispatch_async(dispatch_get_main_queue(), ^{
+                [PithosUtilities httpRequestErrorAlertWithRequest:applyMetadataContainerRequest];
+            });
+            @synchronized(self) {
+                [applyMetadataContainerRequest release];
+                applyMetadataContainerRequest = nil;
+            }
+        } else if ([request isEqualTo:refreshMetadataContainerRequest]) {
+            dispatch_async(dispatch_get_main_queue(), ^{
+                [PithosUtilities httpRequestErrorAlertWithRequest:refreshMetadataContainerRequest];
+            });
+            @synchronized(self) {
+                [refreshMetadataContainerRequest release];
+                refreshMetadataContainerRequest = nil;
+            }
         }
     }
     [pool drain];
diff --git a/pithos-macos/PithosObjectNode.m b/pithos-macos/PithosObjectNode.m
index a3afc36..9f6f4e0 100644
--- a/pithos-macos/PithosObjectNode.m
+++ b/pithos-macos/PithosObjectNode.m
@@ -78,6 +78,15 @@
 #pragma mark -
 #pragma mark Properties
 
+- (void)setPithos:(ASIPithos *)aPithos {
+    if (aPithos && ![aPithos isEqualTo:pithos]) {
+        [pithos release];
+        pithos = [aPithos retain];
+        [url release];
+        url = nil;
+    }
+}
+
 - (NSString *)url {
     if (url == nil)
         url = [[NSString alloc] initWithFormat:@"object %@/%@/%@%@", 
@@ -153,17 +162,39 @@
 
 - (void)objectRequestFailed:(ASIPithosObjectRequest *)request {
     NSAutoreleasePool *pool = [[NSAutoreleasePool alloc] init];
-    if ([request isEqualTo:applyMetadataObjectRequest]) {
-        [PithosUtilities httpRequestErrorAlertWithRequest:applyMetadataObjectRequest];
-        @synchronized(self) {
-            [applyMetadataObjectRequest release];
-            applyMetadataObjectRequest = nil;
+    NSUInteger retries = [[request.userInfo objectForKey:@"retries"] unsignedIntegerValue];
+    if (retries > 0) {
+        ASIPithosObjectRequest *newRequest = (ASIPithosObjectRequest *)[PithosUtilities copyRequest:request];
+        [(NSMutableDictionary *)(newRequest.userInfo)setObject:[NSNumber numberWithUnsignedInteger:(--retries)] forKey:@"retries"];
+        if ([request isEqualTo:applyMetadataObjectRequest]) {
+            @synchronized(self) {
+                [applyMetadataObjectRequest release];
+                applyMetadataObjectRequest = newRequest;
+            }
+        } else if ([request isEqualTo:refreshMetadataObjectRequest]) {
+            @synchronized(self) {
+                [refreshMetadataObjectRequest release];
+                refreshMetadataObjectRequest = newRequest;
+            }
         }
-    } else if ([request isEqualTo:refreshMetadataObjectRequest]) {
-        [PithosUtilities httpRequestErrorAlertWithRequest:refreshMetadataObjectRequest];
-        @synchronized(self) {
-            [refreshMetadataObjectRequest release];
-            refreshMetadataObjectRequest = nil;
+        [[PithosUtilities prepareRequest:newRequest priority:[[newRequest.userInfo objectForKey:@"priority"] integerValue]] startAsynchronous];
+    } else {
+        if ([request isEqualTo:applyMetadataObjectRequest]) {
+            dispatch_async(dispatch_get_main_queue(), ^{
+                [PithosUtilities httpRequestErrorAlertWithRequest:applyMetadataObjectRequest];
+            });
+            @synchronized(self) {
+                [applyMetadataObjectRequest release];
+                applyMetadataObjectRequest = nil;
+            }
+        } else if ([request isEqualTo:refreshMetadataObjectRequest]) {
+            dispatch_async(dispatch_get_main_queue(), ^{
+                [PithosUtilities httpRequestErrorAlertWithRequest:refreshMetadataObjectRequest];
+            });
+            @synchronized(self) {
+                [refreshMetadataObjectRequest release];
+                refreshMetadataObjectRequest = nil;
+            }
         }
     }
     [pool drain];
diff --git a/pithos-macos/PithosPreferencesController.h b/pithos-macos/PithosPreferencesController.h
index c14d19a..5fd4245 100644
--- a/pithos-macos/PithosPreferencesController.h
+++ b/pithos-macos/PithosPreferencesController.h
@@ -2,7 +2,7 @@
 //  PithosPreferencesController.h
 //  pithos-macos
 //
-// Copyright 2011 GRNET S.A. All rights reserved.
+// Copyright 2011-2012 GRNET S.A. All rights reserved.
 //
 // Redistribution and use in source and binary forms, with or
 // without modification, are permitted provided that the following
@@ -37,25 +37,64 @@
 
 #import <Cocoa/Cocoa.h>
 @class PithosBrowserController;
+@class PithosAccount;
 
 @interface PithosPreferencesController : NSWindowController <NSWindowDelegate> {
     PithosBrowserController *pithosBrowserController;
+    PithosAccount *selectedPithosAccount;
     
-    NSDictionaryController *groupsDictionaryController;
-    NSDictionaryController *selectedGroupMembersDictionaryController;
+    NSArrayController *accountsArrayController;
     
+    BOOL accountRemoveEnable;
+    
+    NSString *serverURL;
+    NSString *authUser;
+    NSString *authToken;
     BOOL manual;
+    BOOL loginEnable;
+    BOOL loginCancelEnable;
+    
+    BOOL syncActive;
+    NSString *syncDirectoryPath;
+    BOOL syncApplyEnable;
+    BOOL syncCancelEnable;
+    
+    NSDictionaryController *groupsDictionaryController;
+    NSDictionaryController *selectedGroupMembersDictionaryController;
 }
 
 @property (nonatomic, assign) IBOutlet PithosBrowserController *pithosBrowserController;
+@property (nonatomic, retain) PithosAccount *selectedPithosAccount;
+
+@property (nonatomic, assign) IBOutlet NSArrayController *accountsArrayController;
+
+@property (nonatomic, assign) BOOL accountRemoveEnable;
+
+@property (nonatomic, retain) NSString *serverURL;
+@property (nonatomic, retain) NSString *authUser;
+@property (nonatomic, retain) NSString *authToken;
+@property (nonatomic, assign) BOOL manual;
+@property (nonatomic, assign) BOOL loginEnable;
+@property (nonatomic, assign) BOOL loginCancelEnable;
+
+@property (nonatomic, assign) BOOL syncActive;
+@property (nonatomic, retain) NSString *syncDirectoryPath;
+@property (nonatomic, assign) BOOL syncApplyEnable;
+@property (nonatomic, assign) BOOL syncCancelEnable;
 
 @property (nonatomic, assign) IBOutlet NSDictionaryController *groupsDictionaryController;
 @property (nonatomic, assign) IBOutlet NSDictionaryController *selectedGroupMembersDictionaryController;
 
-@property (nonatomic, assign) BOOL manual;
+//- (IBAction)toolbarItemSelected:(id)sender;
 
-- (IBAction)toolbarItemSelected:(id)sender;
+- (IBAction)addAccount:(id)sender;
+- (IBAction)removeAccount:(id)sender;
+- (IBAction)login:(id)sender;
+- (IBAction)loginCancel:(id)sender;
+- (IBAction)syncApply:(id)sender;
+- (IBAction)syncCancel:(id)sender;
+- (IBAction)groupsApply:(id)sender;
+- (IBAction)groupsRevert:(id)sender;
 
-- (IBAction)authenticationLogin:(id)sender;
 
 @end
